
# 资产负债表
BALANCESHEET_ITEMS = [
    "acc_payable",
    "acc_receivable",
    "acct_payable",
    "acct_receivable",
    "adv_receipt",
    "anticipation_liab",
    "bonds_payable",
    "cap_resv",
    "cap_stock",
    "comp_id",
    "comp_type_code",
    "const_in_proc",
    "const_in_proc_total",
    "cont_liabilities",
    "currency_cap",
    "currency_code",
    "deferred_inc_noncur_liab",
    "deferred_tax_assets",
    "deferred_tax_liab",
    "div_payable",
    "div_receivable",
    "empl_pay_payable",
    "fixed_assets",
    "fixed_assets_total",
    "int_receivable",
    "intangible_assets",
    "interest_payable",
    "inv",
    "inv_realestate",
    "lease_liability",
    "less_treasury_stk",
    "lt_deferred_exp",
    "lt_equity_inv",
    "lt_loan",
    "minority_equity",
    "noncur_assets_due_within_1y",
    "noncur_liab_due_within_1y",
    "notes_payable",
    "notes_receivable",
    "oth_comp_income",
    "oth_equity_tools",
    "oth_noncur_assets",
    "other_cur_assets",
    "other_cur_liab",
    "other_equity_inv",
    "other_noncur_fin_assets",
    "other_noncur_liab",
    "other_payable",
    "other_payable_total",
    "other_rcv_total",
    "other_receivable",
    "prepayment",
    "report_type",
    "reporting_period",
    "security_name",
    "st_borrowing",
    "surplus_resv",
    "tax_payable",
    "tot_noncur_assets",
    "tot_share",
    "tot_share_equity_excl_min_int",
    "tot_share_equity_incl_min_int",
    "total_assets",
    "total_cur_assets",
    "total_cur_liab",
    "total_liab",
    "total_liab_share_equity",
    "total_noncur_liab",
    "trading_finassets",
    "undistributed_pro",
    "use_right_assets",
    "develop_exp",
    "goodwill",
    "debt_inv",
    "rcv_financing",
    "special_resv",
    "engin_mat",
    "lt_payable",
    "lt_payable_total",
    "lt_receivables",
    "special_payable",
    "cont_assets",
    "disposal_fix_assets",
    "trading_fin_liab",
    "nom_risks_prep",
    "deri_fin_liab",
    "lt_emp_comp_pay",
    "der_fin_assets",
    "hold_assets_for_sale",
    "lia_hfs",
    "oth_equity_tools_pre_shr",
    "other_debt_inv",
    "other_sustain_bond",
    "st_bonds_payable",
    "act_trading_sec",
    "loans_and_advances",
    "loans_from_oth_banks",
    "red_mon_cap_for_sale",
    "sell_repo_fin_assets",
    "settle_funds",
    "spe_cur_assets_diff",
    "prod_bio_assets",
    "dep_received_ib_dep",
    "lending_funds",
    "oil_and_gas_assets",
    "act_uw_sec",
    "ced_insur_cont_reserves_rcv",
    "loan_central_bank",
    "payable_for_reinsurer",
    "receivable_prem",
    "reinsurance_acc_rcv",
    "service_charge_comm_payable",
    "spe_noncur_assets_diff",
    "spe_cur_liab_diff",
    "spe_noncur_liab_diff",
    "tot_cur_assets_diff",
    "tot_cur_liab_diff",
    "tot_noncur_assets_diff",
    "tot_noncur_liab_diff",
    "tot_share_equity_bal_diff",
    "rsrv_fund_insur_cont",
    "acc_receivables",
    "clients_fund_deposit",
    "clients_reserves",
    "gua_deposits_paid",
    "lend_funds",
    "other_assets",
    "other_liab",
    "payable",
    "st_fin_payable",
    "spe_assets_bal_diff",
    "asset_dep_funds_oth_fin_inst",
    "cash_central_bank_deposits",
    "deposit_taking",
    "liab_dep_funds_oth_fin_inst",
    "precious_metal",
    "adv_prem",
    "deposit_cap_recog",
    "fixed_term_deposits",
    "spe_liab_bal_diff",
    "fin_assets_cost_sharing",
    "fin_assets_fair_value",
    "agency_assets",
    "spe_share_equity_bal_diff",
    "incl_trading_seat_fees",
    "claims_payable",
    "fin_assets_ava_for_sale",
    "hold_to_mty_inv",
    "ind_acct_assets",
    "ind_acct_liab",
    "insured_deposit_inv",
    "insured_div_payable",
    "life_insur_resv",
    "lt_health_insur_resv",
    "out_loss_resv",
    "rcv_ced_claim_resv",
    "rcv_ced_life_insur_resv",
    "rcv_ced_lt_health_insur_resv",
    "rcv_ced_unearned_prem_resv",
    "unearned_prem_resv",
    "tot_assets_bal_diff",
    "tot_liab_bal_diff",
    "tot_liab_equity_bal_diff",
    "gua_pledge_loans",
    "rcv_inv",
]

# 利润表
INCOME_ITEMS = [
    "amort_cost_fin_assets_ear",
    "basic_eps",
    "comp_id",
    "comp_type_code",
    "continued_net_opera_pro",
    "credit_impair_loss",
    "currency_code",
    "diluted_eps",
    "div_exp_insur",
    "ebit",
    "end_net_opera_pro",
    "ext_insur_cont_rsrv",
    "fin_exp_int_exp",
    "fin_exp_int_inc",
    "gain_disposal_assets",
    "handling_chrg_comm_fee",
    "incl_inc_inv_jv_entp",
    "income_tax",
    "insur_prem",
    "interest_inc",
    "is_calculation",
    "less_admin_exp",
    "less_assets_impair_loss",
    "less_bus_tax_surcharge",
    "less_fin_exp",
    "less_handling_chrg_comm_fee",
    "less_interest_exp",
    "less_non_opera_exp",
    "less_opera_cost",
    "less_selling_exp",
    "min_int_inc",
    "net_exposure_hedging_gain",
    "net_pro_after_ded_nr_gl",
    "net_pro_excl_min_int_inc",
    "net_pro_incl_min_int_inc",
    "opera_profit",
    "opera_rev",
    "oth_compre_inc",
    "oth_income",
    "plus_net_fx_inc",
    "plus_net_gain_chg_fv",
    "plus_net_inv_inc",
    "plus_non_opera_rev",
    "rd_exp",
    "reinsurance_exp",
    "report_type",
    "reporting_period",
    "security_name",
    "surr_value",
    "tot_compen_exp",
    "tot_compre_inc",
    "tot_compre_inc_min_share",
    "tot_compre_inc_parent_comp",
    "tot_opera_cost",
    "tot_opera_cost2",
    "tot_opera_rev",
    "total_profit",
    "net_pro_under_int_acc_sta",
    "net_handling_chrg_comm_fee",
    "net_inc_ec_asset_mgmt_bus",
    "net_inc_sec_brok_bus",
    "net_inc_sec_uw_bus",
    "net_interest_inc",
    "opera_exp",
    "oth_assets_impair_loss",
    "oth_bus_cost",
    "oth_bus_inc",
    "oth_net_opera_inc",
    "plus_oth_net_bus_inc",
    "tot_bal_tot_pro_marg",
    "ext_unearned_prem_res",
    "incl_reinsur_prem_inc",
    "less_amort_compen_exp",
    "less_amort_insur_cont_rsrv",
    "less_amort_reinsur_exp",
    "less_reinsur_prem",
    "prem_bus_inc",
    "tot_bal_net_pro_marg",
    "comments",
    "ebitda",
    "tot_bal_opera_pro_marg",
    "distributive_pro_shareholder",
    "beg_undistributed_pro",
    "common_stock_div_payable",
    "distributive_pro",
    "spe_bal_opera_pro_marg",
    "transfer_others",

]

# 现金流量表
CASHFLOW_ITEMS = [
    "beg_bal_cash_cash_equ",
    "cash_paid_inv",
    "cash_paid_pur_const_fiolta",
    "cash_pay_dist_div_pro_int",
    "cash_pay_employee",
    "cash_pay_for_debt",
    "cash_pay_goods_services",
    "cash_rece_borrow",
    "cash_recp_inv_income",
    "cash_recp_recov_inv",
    "cash_recp_sg_and_rs",
    "comp_id",
    "comp_type_code",
    "currency_code",
    "eff_fx_fluc_cash",
    "end_bal_cash_cash_equ",
    "free_cash_flow",
    "is_calculation",
    "net_cash_flows_fin_act",
    "net_cash_flows_inv_act",
    "net_cash_flows_opera_act",
    "net_cash_recp_disp_fiolta",
    "net_incr_cash_and_cash_equ",
    "oth_cash_pay_opera_act",
    "other_cash_pay_fin_act",
    "other_cash_recp_fin_act",
    "other_cash_recp_oper_act",
    "pay_all_tax",
    "recp_tax_refund",
    "report_type",
    "reporting_period",
    "security_name",
    "tot_cash_inflow_fin_act",
    "tot_cash_inflow_inv_act",
    "tot_cash_inflow_oper_act",
    "tot_cash_outflow_fin_act",
    "tot_cash_outflow_inv_act",
    "tot_cash_outflow_opera_act",
    "cash_rece_issue_bonds",
    "oth_cash_pay_inv_act",
    "oth_cash_recp_inv_act",
    "absorb_cash_recp_inv",
    "incl_cash_recp_saims",
    "incl_div_pro_paid_sms",
    "net_cash_recp_disp_sobu",
    "net_cash_paid_sobu",
    "cash_for_charge",
    "net_incr_borr_fund",
    "net_incr_borr_ofi",
    "net_incr_cus_loan_adv",
    "net_incr_dep_cb_ib",
    "net_incr_dep_cus_and_ib",
    "net_incr_int_and_charge",
    "net_incr_loans_central_bank",
    "net_incr_repu_bus_fund",
    "cash_paid_insur_policy",
    "cash_pay_claims_oic",
    "cash_recp_prem_oic",
    "net_cash_rec_sec",
    "net_cash_recp_reinsu_bus",
    "net_incr_insured_save",
    "net_incr_pledge_loan",
    "net_incr_dismantle_cap",
    "spe_bal_cash_inflow_fin_act",
    "spe_bal_cash_inflow_inv_act",
    "spe_bal_cash_inflow_opera_act",
    "spe_bal_cash_outflow_inv",
    "spe_bal_cash_outflow_opera",
    "spe_bal_cash_outflow_fin",
    "tot_bal_netcash_incr_diff",
    "cash_end_bal",
    "decr_opera_receivable",
    "incr_opera_payable",
    "ind_net_cash_flows_opera_act",
    "ind_net_incr_cash_and_equ",
    "less_open_bal_cash",
    "loss_disp_fiolta",
    "loss_fairvalue_chg",
    "net_profit",
    "plus_assets_depre_prep",
    "spe_bal_netcash_opera_ind",
    "inv_loss",
    "plus_end_bal_cash_equ",
    "less_open_bal_cash_equ",
    "net_incr_disp_tfa",
    "tot_bal_cash_inflow_opera_act",
    "tot_bal_netcash_flow_inv",
    "amort_intan_assets",
    "amort_lt_deferred_exp",
    "credit_impair_loss",
    "decr_defe_inc_tax_assets",
    "decr_inventory",
    "depre_fa_oga_pba",
    "financial_exp",
    "incr_defe_inc_tax_liab",
    "use_right_asset_dep",
    "loss_fixed_assets",
    "tot_bal_cash_outflow_opera",
    "tot_bal_cash_outflow_fin",
    "tot_bal_cash_outflow_inv",
    "tot_bal_netcash_flow_opera",
    "tot_bal_netcash_opera_ind",
    "spe_bal_netcash_inc_diff_ind",
    "decr_deferred_expense",
    "tot_bal_cash_inflow_inv_act",
    "tot_bal_cash_inflow_fin_act",
    "tot_bal_netcash_flow_fin",
    "fixed_assets_fin_lease",
    "tot_bal_netcash_inc_diff_ind",
    "conv_debt_into_cap",
    "conv_corp_bonds_due_within_1y",
    "others",

]